---
import BasicLayout from "@layouts/Basic.astro";
import { nhost } from "@utils/NhostClient.js";
import { yearFormatting, slugFromFilename } from "@utils/formatting";
import "@styles/articleLayout.css";

// Let's get the philosophers static paths and their data, to create their pages:
// - https://docs.astro.build/en/core-concepts/routing/#dynamic-routes
export async function getStaticPaths() {
  // First we get the texts from the Markdown files:
  // - https://docs.astro.build/en/guides/markdown-content/#importing-markdown
  // - https://docs.astro.build/en/reference/api-reference/#astroglob
  const philosophersMarkdowns = await Astro.glob("../../content/people/*.md");
  // Now we get the philosophers list, their other info and associations from the database:
  const response = await nhost.graphql.request(`
    query {
      people {
        name
        slug
        birth_location
        birth_year
        birth_year_estimation
        death_year
        death_year_estimation
        concepts(order_by: {concept: {title: asc}}) {
          concept {
            title
            slug
          }
        }
      }
    }
  `);
  // For each philosopher we get his/her content from his/her Markdown file and their params (paths to build) and props (other info):
  const pathsAndProps = response.data.people.map((person) => {
    const philosopherMarkdownContent = philosophersMarkdowns.find(
      (markdown) => slugFromFilename(markdown.file) == person.slug
    ).Content;
    return {
      params: { slug: person.slug },
      props: {
        name: person.name,
        birth_location: person.birth_location,
        birth_year: person.birth_year,
        birth_year_estimation: person.birth_year_estimation,
        death_year: person.death_year,
        death_year_estimation: person.death_year_estimation,
        relatedConcepts: person.concepts,
        Content: philosopherMarkdownContent,
      },
    };
  });
  return pathsAndProps;
}

// Now we prepare the data for each page/philosopher:
// - Destructing the props into individual constants for easier use below:
const {
  name,
  birth_location,
  birth_year,
  birth_year_estimation,
  death_year,
  death_year_estimation,
  relatedConcepts,
  Content,
} = Astro.props;
// - Preparing the related concepts list (if any):
var conceptsNav;
const conceptsIndex = `<a class="goToIndex" href="/conceitos/">índice de conceitos</a>`;
if (relatedConcepts.length > 0) {
  conceptsNav =
    `<ul>` +
    relatedConcepts
      .map(
        (relatedConcept) =>
          `<li><a href="/conceito/${relatedConcept.concept.slug}">${relatedConcept.concept.title}</a></li>`
      )
      .join("\n") +
    `</ul>` +
    conceptsIndex;
} else {
  conceptsNav = `<p>Não há nenhum conceito relacionado.</p>` + conceptsIndex;
}

// The content for page metadata & Open Graph metadata:
const canonicalURL = new URL(Astro.url.pathname, Astro.site);
const metaTitle = name;
const metaDescription = `Sobre o(a) filósofo(a) ${name}.`;
const metaCanonicalURL = canonicalURL.href;
const metaType = "website";
const metaImage =
  canonicalURL.origin + "/images/Rembrandt_-_The_Philosopher_in_Meditation.jpg";
---

<BasicLayout
  metaTitle={metaTitle}
  metaDescription={metaDescription}
  metaCanonicalURL={metaCanonicalURL}
  metaType={metaType}
  metaImage={metaImage}
>
  <article>
    <h1>{name}</h1>

    <p>
      Nasceu em {yearFormatting(birth_year, birth_year_estimation)}, em {
        birth_location
      }.
      {
        death_year
          ? "Morreu em " + yearFormatting(death_year, death_year_estimation)
          : ""
      }
    </p>

    <Content />
  </article>

  <nav class="navSide" set:html={conceptsNav}>
    <h2>Conceitos relacionados</h2>
  </nav>

  <a class="backToIndex" href="/filosofos">índice de filósofos(as)</a>
</BasicLayout>
